Index: branches/2013/dev_LOCEAN_CMCC_INGV_2013/NEMOGCM/NEMO/OPA_SRC/LBC/lib_mpp.F90
===================================================================
--- branches/2013/dev_LOCEAN_CMCC_INGV_2013/NEMOGCM/NEMO/OPA_SRC/LBC/lib_mpp.F90	(revision 4229)
+++ branches/2013/dev_LOCEAN_CMCC_INGV_2013/NEMOGCM/NEMO/OPA_SRC/LBC/lib_mpp.F90	(revision 4230)
@@ -22,5 +22,6 @@
    !!                          'mpp_lnk_bdy_2d' and 'mpp_lnk_obc_2d' routines and update
    !!                          the mppobc routine to optimize the BDY and OBC communications
-   !!            3.6  !  2013  ( C. Ethe, G. Madec ) message passing arrays as local variables 
+   !!            3.5  !  2013  ( C. Ethe, G. Madec ) message passing arrays as local variables 
+   !!            3.5  !  2013 (S.Mocavero, I.Epicoco - CMCC) north fold optimizations
    !!----------------------------------------------------------------------
 
@@ -151,10 +152,5 @@
    REAL(wp), DIMENSION(:), ALLOCATABLE, SAVE :: tampon  ! buffer in case of bsend
 
-   ! North fold arrays used to minimise the use of allgather operations. Set in nemo_northcomms (nemogcm) so need to be public
-   INTEGER, PUBLIC,  PARAMETER :: jpmaxngh = 8                 ! Assumed maximum number of active neighbours
-   INTEGER, PUBLIC,  PARAMETER :: jptyps   = 5                 ! Number of different neighbour lists to be used for northfold exchanges
-   INTEGER, PUBLIC,  DIMENSION (jpmaxngh,jptyps)    ::   isendto
-   INTEGER, PUBLIC,  DIMENSION (jptyps)             ::   nsndto
-   LOGICAL, PUBLIC                                  ::   ln_nnogather     = .FALSE.  ! namelist control of northfold comms
+   LOGICAL, PUBLIC                                  ::   ln_nnogather       ! namelist control of northfold comms
    LOGICAL, PUBLIC                                  ::   l_north_nogather = .FALSE.  ! internal control of northfold comms
    INTEGER, PUBLIC                                  ::   ityp
@@ -2592,10 +2588,10 @@
       CHARACTER(len=1)                , INTENT(in   ) ::   cd_type   ! nature of pt3d grid-points
       !                                                              !   = T ,  U , V , F or W  gridpoints
-      REAL(wp)                        , INTENT(in   ) ::   psgn      ! = -1. the sign change across the north fold
+      REAL(wp)                        , INTENT(in   ) ::   psgn      ! = -1. the sign change across the north fold 
       !!                                                             ! =  1. , the sign is kept
-      INTEGER ::   ji, jj, jr
+      INTEGER ::   ji, jj, jr, jk
       INTEGER ::   ierr, itaille, ildi, ilei, iilb
       INTEGER ::   ijpj, ijpjm1, ij, iproc
-      INTEGER, DIMENSION (jpmaxngh)          ::   ml_req_nf          ! for mpi_isend when avoiding mpi_allgather
+      INTEGER, DIMENSION (jpmaxngh)          ::   ml_req_nf          !for mpi_isend when avoiding mpi_allgather
       INTEGER                                ::   ml_err             ! for mpi_isend when avoiding mpi_allgather
       INTEGER, DIMENSION(MPI_STATUS_SIZE)    ::   ml_stat            ! for mpi_isend when avoiding mpi_allgather
@@ -2604,82 +2600,88 @@
       REAL(wp), DIMENSION(:,:,:)  , ALLOCATABLE   :: znorthloc, zfoldwk      
       REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE   :: znorthgloio
-
-      !!----------------------------------------------------------------------
-      !
-      ALLOCATE( ztab(jpiglo,4,jpk), znorthloc(jpi,4,jpk), zfoldwk(jpi,4,jpk), znorthgloio(jpi,4,jpk,jpni) )
+      REAL(wp), DIMENSION(:,:,:)  , ALLOCATABLE   :: ztabl, ztabr
+
+      INTEGER :: istatus(mpi_status_size)
+      INTEGER :: iflag
+      !!----------------------------------------------------------------------
+      !
+      ALLOCATE( ztab(jpiglo,4,jpk) , znorthloc(jpi,4,jpk), zfoldwk(jpi,4,jpk), znorthgloio(jpi,4,jpk,jpni) )
+      ALLOCATE( ztabl(jpi,4,jpk), ztabr(jpi*jpmaxngh, 4, jpk) ) 
 
       ijpj   = 4
-      ityp = -1
       ijpjm1 = 3
-      ztab(:,:,:) = 0.e0
-      !
-      DO jj = nlcj - ijpj +1, nlcj          ! put in znorthloc the last 4 jlines of pt3d
-         ij = jj - nlcj + ijpj
-         znorthloc(:,ij,:) = pt3d(:,jj,:)
+      !
+      DO jk = 1, jpk
+         DO jj = nlcj - ijpj +1, nlcj          ! put in xnorthloc the last 4 jlines of pt3d
+            ij = jj - nlcj + ijpj
+            znorthloc(:,ij,jk) = pt3d(:,jj,jk)
+         END DO
       END DO
       !
       !                                     ! Build in procs of ncomm_north the znorthgloio
       itaille = jpi * jpk * ijpj
+
+
       IF ( l_north_nogather ) THEN
          !
-         ! Avoid the use of mpi_allgather by exchanging only with the processes already identified
-         ! (in nemo_northcomms) as being  involved in this process' northern boundary exchange
-         !
-         DO jj = nlcj-ijpj+1, nlcj          ! First put local values into the global array
-            ij = jj - nlcj + ijpj
-            DO ji = 1, nlci
-               ztab(ji+nimpp-1,ij,:) = pt3d(ji,jj,:)
+        ztabr(:,:,:) = 0
+        DO jk = 1, jpk
+           DO jj = nlcj-ijpj+1, nlcj          ! First put local values into the global array
+              ij = jj - nlcj + ijpj
+              DO ji = 1, nlci
+                 ztabl(ji,ij,jk) = pt3d(ji,jj,jk)
+              END DO
+           END DO
+        END DO
+
+         DO jr = 1,nsndto
+            IF (isendto(jr) .ne. narea) CALL mppsend( 5, znorthloc, itaille, isendto(jr)-1, ml_req_nf(jr) )
+         END DO
+         DO jr = 1,nsndto
+            iproc = isendto(jr)
+            ildi = nldit (iproc)
+            ilei = nleit (iproc)
+            iilb = nimppt(isendto(jr)) - nimppt(isendto(1))
+            IF(isendto(jr) .ne. narea) THEN
+              CALL mpprecv(5, zfoldwk, itaille, isendto(jr)-1)
+              DO jk = 1, jpk
+                 DO jj = 1, ijpj
+                    DO ji = 1, ilei
+                       ztabr(iilb+ji,jj,jk) = zfoldwk(ji,jj,jk)
+                    END DO
+                 END DO
+              END DO
+           ELSE
+              DO jk = 1, jpk
+                 DO jj = 1, ijpj
+                    DO ji = 1, ilei
+                       ztabr(iilb+ji,jj,jk) = pt3d(ji,nlcj-ijpj+jj,jk)
+                    END DO
+                 END DO
+              END DO
+           ENDIF
+         END DO
+         IF (l_isend) THEN
+            DO jr = 1,nsndto
+               IF (isendto(jr) .ne. narea) CALL mpi_wait(ml_req_nf(jr), ml_stat, ml_err)
             END DO
-         END DO
-
-         !
-         ! Set the exchange type in order to access the correct list of active neighbours
-         !
-         SELECT CASE ( cd_type )
-            CASE ( 'T' , 'W' )
-               ityp = 1
-            CASE ( 'U' )
-               ityp = 2
-            CASE ( 'V' )
-               ityp = 3
-            CASE ( 'F' )
-               ityp = 4
-            CASE ( 'I' )
-               ityp = 5
-            CASE DEFAULT
-               ityp = -1                    ! Set a default value for unsupported types which
-                                            ! will cause a fallback to the mpi_allgather method
-         END SELECT
-         IF ( ityp .gt. 0 ) THEN
-
-            DO jr = 1,nsndto(ityp)
-               CALL mppsend(5, znorthloc, itaille, isendto(jr,ityp), ml_req_nf(jr) )
-            END DO
-            DO jr = 1,nsndto(ityp)
-               CALL mpprecv(5, zfoldwk, itaille, isendto(jr,ityp))
-               iproc = isendto(jr,ityp) + 1
-               ildi = nldit (iproc)
-               ilei = nleit (iproc)
-               iilb = nimppt(iproc)
-               DO jj = 1, ijpj
-                  DO ji = ildi, ilei
-                     ztab(ji+iilb-1,jj,:) = zfoldwk(ji,jj,:)
-                  END DO
+         ENDIF
+         CALL mpp_lbc_nfd( ztabl, ztabr_3d, cd_type, psgn )   ! North fold boundary condition
+         !
+         DO jk = 1, jpk
+            DO jj = nlcj-ijpj+1, nlcj             ! Scatter back to pt3d
+               ij = jj - nlcj + ijpj
+               DO ji= 1, nlci
+                  pt3d(ji,jj,jk) = ztabl(ji,ij,jk)
                END DO
             END DO
-            IF (l_isend) THEN
-               DO jr = 1,nsndto(ityp)
-                  CALL mpi_wait(ml_req_nf(jr), ml_stat, ml_err)
-               END DO
-            ENDIF
-
-         ENDIF
-
-      ENDIF
-
-      IF ( ityp .lt. 0 ) THEN
+         END DO
+         !
+
+      ELSE
          CALL MPI_ALLGATHER( znorthloc  , itaille, MPI_DOUBLE_PRECISION,                &
             &                znorthgloio, itaille, MPI_DOUBLE_PRECISION, ncomm_north, ierr )
          !
+         ztab(:,:,:) = 0.e0
          DO jr = 1, ndim_rank_north         ! recover the global north array
             iproc = nrank_north(jr) + 1
@@ -2687,10 +2689,23 @@
             ilei  = nleit (iproc)
             iilb  = nimppt(iproc)
-            DO jj = 1, ijpj
-               DO ji = ildi, ilei
-                  ztab(ji+iilb-1,jj,:) = znorthgloio(ji,jj,:,jr)
+            DO jk = 1, jpk
+               DO jj = 1, ijpj
+                  DO ji = ildi, ilei
+                    ztab(ji+iilb-1,jj,jk) = znorthgloio(ji,jj,jk,jr)
+                  END DO
                END DO
             END DO
          END DO
+         CALL lbc_nfd( ztab, cd_type, psgn )   ! North fold boundary condition
+         !
+         DO jk = 1, jpk
+            DO jj = nlcj-ijpj+1, nlcj             ! Scatter back to pt3d
+               ij = jj - nlcj + ijpj
+               DO ji= 1, nlci
+                  pt3d(ji,jj,jk) = ztab(ji+nimpp-1,ij,jk)
+               END DO
+            END DO
+         END DO
+         !
       ENDIF
       !
@@ -2704,12 +2719,15 @@
       CALL lbc_nfd( ztab, cd_type, psgn )   ! North fold boundary condition
       !
-      DO jj = nlcj-ijpj+1, nlcj             ! Scatter back to pt3d
-         ij = jj - nlcj + ijpj
-         DO ji= 1, nlci
-            pt3d(ji,jj,:) = ztab(ji+nimpp-1,ij,:)
-         END DO
+      DO jk = 1, jpk
+         DO jj = nlcj-ijpj+1, nlcj             ! Scatter back to pt3d
+            ij = jj - nlcj + ijpj
+            DO ji= 1, nlci
+               pt3d(ji,jj,jk) = ztab(ji+nimpp-1,ij,jk)
+            END DO
+        END DO
       END DO
       !
       DEALLOCATE( ztab, znorthloc, zfoldwk, znorthgloio )
+      DEALLOCATE( ztabl, ztabr ) 
       !
    END SUBROUTINE mpp_lbc_north_3d
@@ -2730,13 +2748,13 @@
       !!
       !!----------------------------------------------------------------------
-      REAL(wp), DIMENSION(jpi,jpj), INTENT(inout) ::   pt2d      ! 3D array on which the b.c. is applied
-      CHARACTER(len=1)            , INTENT(in   ) ::   cd_type   ! nature of pt3d grid-points
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(inout) ::   pt2d      ! 2D array on which the b.c. is applied
+      CHARACTER(len=1)            , INTENT(in   ) ::   cd_type   ! nature of pt2d grid-points
       !                                                          !   = T ,  U , V , F or W  gridpoints
-      REAL(wp)                    , INTENT(in   ) ::   psgn      ! = -1. the sign change across the north fold
+      REAL(wp)                    , INTENT(in   ) ::   psgn      ! = -1. the sign change across the north fold 
       !!                                                             ! =  1. , the sign is kept
       INTEGER ::   ji, jj, jr
       INTEGER ::   ierr, itaille, ildi, ilei, iilb
       INTEGER ::   ijpj, ijpjm1, ij, iproc
-      INTEGER, DIMENSION (jpmaxngh)      ::   ml_req_nf          ! for mpi_isend when avoiding mpi_allgather
+      INTEGER, DIMENSION (jpmaxngh)      ::   ml_req_nf          !for mpi_isend when avoiding mpi_allgather
       INTEGER                            ::   ml_err             ! for mpi_isend when avoiding mpi_allgather
       INTEGER, DIMENSION(MPI_STATUS_SIZE)::   ml_stat            ! for mpi_isend when avoiding mpi_allgather
@@ -2745,12 +2763,14 @@
       REAL(wp), DIMENSION(:,:)  , ALLOCATABLE   :: znorthloc, zfoldwk      
       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE   :: znorthgloio
+      REAL(wp), DIMENSION(:,:)  , ALLOCATABLE   :: ztabl, ztabr
+      INTEGER :: istatus(mpi_status_size)
+      INTEGER :: iflag
       !!----------------------------------------------------------------------
       !
       ALLOCATE( ztab(jpiglo,4), znorthloc(jpi,4), zfoldwk(jpi,4), znorthgloio(jpi,4,jpni) )
+      ALLOCATE( ztabl(jpi,4), ztabr(jpi*jpmaxngh, 4) ) 
       !
       ijpj   = 4
-      ityp = -1
       ijpjm1 = 3
-      ztab(:,:) = 0.e0
       !
       DO jj = nlcj-ijpj+1, nlcj             ! put in znorthloc the last 4 jlines of pt2d
@@ -2763,64 +2783,57 @@
       IF ( l_north_nogather ) THEN
          !
-         ! Avoid the use of mpi_allgather by exchanging only with the processes already identified
+         ! Avoid the use of mpi_allgather by exchanging only with the processes already identified 
          ! (in nemo_northcomms) as being  involved in this process' northern boundary exchange
          !
+         ztabr(:,:) = 0
          DO jj = nlcj-ijpj+1, nlcj          ! First put local values into the global array
             ij = jj - nlcj + ijpj
             DO ji = 1, nlci
-               ztab(ji+nimpp-1,ij) = pt2d(ji,jj)
+               ztabl(ji,ij) = pt2d(ji,jj)
             END DO
          END DO
 
-         !
-         ! Set the exchange type in order to access the correct list of active neighbours
-         !
-         SELECT CASE ( cd_type )
-            CASE ( 'T' , 'W' )
-               ityp = 1
-            CASE ( 'U' )
-               ityp = 2
-            CASE ( 'V' )
-               ityp = 3
-            CASE ( 'F' )
-               ityp = 4
-            CASE ( 'I' )
-               ityp = 5
-            CASE DEFAULT
-               ityp = -1                    ! Set a default value for unsupported types which
-                                            ! will cause a fallback to the mpi_allgather method
-         END SELECT
-
-         IF ( ityp .gt. 0 ) THEN
-
-            DO jr = 1,nsndto(ityp)
-               CALL mppsend(5, znorthloc, itaille, isendto(jr,ityp), ml_req_nf(jr) )
+         DO jr = 1,nsndto
+            IF (isendto(jr) .ne. narea) CALL mppsend(5, znorthloc, itaille, isendto(jr)-1, ml_req_nf(jr))
+         END DO
+         DO jr = 1,nsndto
+            iproc = isendto(jr)
+            ildi = nldit (iproc)
+            ilei = nleit (iproc)
+            iilb = nimppt(isendto(jr)) - nimppt(isendto(1))
+            IF(isendto(jr) .ne. narea) THEN
+              CALL mpprecv(5, zfoldwk, itaille, isendto(jr)-1)
+              DO jj = 1, ijpj
+                 DO ji = 1, ilei
+                    ztabr(iilb+ji,jj) = zfoldwk(ji,jj)
+                 END DO
+              END DO
+            ELSE
+              DO jj = 1, ijpj
+                 DO ji = 1, ilei
+                    ztabr(iilb+ji,jj) = pt2d(ji,nlcj-ijpj+jj)
+                 END DO
+              END DO
+            ENDIF
+         END DO
+         IF (l_isend) THEN
+            DO jr = 1,nsndto
+               IF (isendto(jr) .ne. narea) CALL mpi_wait(ml_req_nf(jr), ml_stat, ml_err)
             END DO
-            DO jr = 1,nsndto(ityp)
-               CALL mpprecv(5, zfoldwk, itaille, isendto(jr,ityp))
-               iproc = isendto(jr,ityp) + 1
-               ildi = nldit (iproc)
-               ilei = nleit (iproc)
-               iilb = nimppt(iproc)
-               DO jj = 1, ijpj
-                  DO ji = ildi, ilei
-                     ztab(ji+iilb-1,jj) = zfoldwk(ji,jj)
-                  END DO
-               END DO
+         ENDIF
+         CALL mpp_lbc_nfd( ztabl, ztabr, cd_type, psgn )   ! North fold boundary condition
+         !
+         DO jj = nlcj-ijpj+1, nlcj             ! Scatter back to pt2d
+            ij = jj - nlcj + ijpj
+            DO ji = 1, nlci
+               pt2d(ji,jj) = ztabl(ji,ij)
             END DO
-            IF (l_isend) THEN
-               DO jr = 1,nsndto(ityp)
-                  CALL mpi_wait(ml_req_nf(jr), ml_stat, ml_err)
-               END DO
-            ENDIF
-
-         ENDIF
-
-      ENDIF
-
-      IF ( ityp .lt. 0 ) THEN
+         END DO
+         !
+      ELSE
          CALL MPI_ALLGATHER( znorthloc  , itaille, MPI_DOUBLE_PRECISION,        &
             &                znorthgloio, itaille, MPI_DOUBLE_PRECISION, ncomm_north, ierr )
          !
+         ztab(:,:) = 0.e0
          DO jr = 1, ndim_rank_north            ! recover the global north array
             iproc = nrank_north(jr) + 1
@@ -2834,24 +2847,16 @@
             END DO
          END DO
-      ENDIF
-      !
-      ! The ztab array has been either:
-      !  a. Fully populated by the mpi_allgather operation or
-      !  b. Had the active points for this domain and northern neighbours populated
-      !     by peer to peer exchanges
-      ! Either way the array may be folded by lbc_nfd and the result for the span of
-      ! this domain will be identical.
-      !
-      CALL lbc_nfd( ztab, cd_type, psgn )   ! North fold boundary condition
-      !
-      !
-      DO jj = nlcj-ijpj+1, nlcj             ! Scatter back to pt2d
-         ij = jj - nlcj + ijpj
-         DO ji = 1, nlci
-            pt2d(ji,jj) = ztab(ji+nimpp-1,ij)
-         END DO
-      END DO
-      !
+         CALL lbc_nfd( ztab, cd_type, psgn )   ! North fold boundary condition
+         !
+         DO jj = nlcj-ijpj+1, nlcj             ! Scatter back to pt2d
+            ij = jj - nlcj + ijpj
+            DO ji = 1, nlci
+               pt2d(ji,jj) = ztab(ji+nimpp-1,ij)
+            END DO
+         END DO
+         !
+      ENDIF
       DEALLOCATE( ztab, znorthloc, zfoldwk, znorthgloio )
+      DEALLOCATE( ztabl, ztabr ) 
       !
    END SUBROUTINE mpp_lbc_north_2d
Index: branches/2013/dev_LOCEAN_CMCC_INGV_2013/NEMOGCM/NEMO/OPA_SRC/SBC/cyclone.F90
===================================================================
--- branches/2013/dev_LOCEAN_CMCC_INGV_2013/NEMOGCM/NEMO/OPA_SRC/SBC/cyclone.F90	(revision 4229)
+++ branches/2013/dev_LOCEAN_CMCC_INGV_2013/NEMOGCM/NEMO/OPA_SRC/SBC/cyclone.F90	(revision 4230)
@@ -98,7 +98,7 @@
          !
          ! (NB: frequency positive => hours, negative => months)
-         !          !    file     ! frequency !  variable ! time intep !  clim   ! 'yearly' or ! weights  ! rotation   !
-         !          !    name     !  (hours)  !   name    !   (T/F)    !  (T/F)  !  'monthly'  ! filename ! pairs      !
-         sn_tc = FLD_N( 'tc_track',     6     ,  'tc'     ,  .true.    , .false. ,   'yearly'  , ''       , ''         )
+         !          !    file     ! frequency !  variable ! time intep !  clim   ! 'yearly' or ! weights  ! rotation   ! land/sea mask !
+         !          !    name     !  (hours)  !   name    !   (T/F)    !  (T/F)  !  'monthly'  ! filename ! pairs      ! filename      !
+         sn_tc = FLD_N( 'tc_track',     6     ,  'tc'     ,  .true.    , .false. ,   'yearly'  , ''       , ''         , ''            )
          !
          !  Namelist is read in namsbc_core
